#!/usr/bin/python

# download_site.py
#   by Tommaso Cucinotta
#   t.cucinotta@sssup.it
#   March, 2001
#   Pisa, Italy

zope_root = '/usr/local/Zope/Zope-2.3.0-linux2-x86'

def call(f, *args, **kw):
    # Call a function ignoring redirect bci errors.
    try:
	s = apply(f,args, kw)
	return s
    except ServerError, v:
        if str(v)[:1] != '3':
            raise sys.exc_info()[0], sys.exc_info()[1], sys.exc_info()[2]

import os, sys, mimetools

sys.path.insert(0,zope_root + '/lib/python')
import ZPublisher.Client
global ServerError
ServerError=ZPublisher.Client.ServerError

folder = fname = server = user = passw = ''
help=0

# Skip script name (argv[0])
i = 1
while (i < len(sys.argv)):
	arg = sys.argv[i]
	i = i + 1
	if arg == '--help' or arg == '-h': help=1
	elif arg[:7] == '--site=':
		folder = arg[7:]
		fname = folder + '.zexp'
	elif arg == '-t':
		folder = sys.argv[i]
		fname = folder + '.zexp'
		i = i + 1
	elif arg[:9] == '--export=': fname = arg[9:]
	elif arg == '-e':
		fname = sys.argv[i]
		i = i + 1
	elif arg[:9] == '--folder=': folder = arg[9:]
	elif arg == '-f':
		folder = sys.argv[i]
		i = i + 1
	elif arg[:9] == '--server=': server = arg[9:]
	elif arg == '-s':
		server = sys.argv[i]
		i = i + 1
	elif arg[:7] == '--user=': user = arg[7:]
	elif arg == '-u':
		user = sys.argv[i]
		i = i + 1
	elif arg[:11] == '--password=': passw = arg[11:]
	elif arg == '-p':
		passw = sys.argv[i]
		i = i + 1
	else:
		print "Unsupported option: " + arg
		sys.exit(-1)

if help:
	print "\nSYNOPSIS"
	print "  update_site.py [options]"
	print "\nDESCRIPTION"
	print "  Exports a zope site from a running Zope server to a"
	print "  local .zexp file."
	print "\nOPTIONS"
	print "  [-h | --help]"
	print "    This help screen."
	print "  [-e filename.zexp | --export=filename.zexp]"
	print "    Where the export from Zope must be written, on the local machine."
	print "  [-f foldername | --folder=foldername]"
	print "    Name of the Zope folder to be exported."
	print "  [-t sitename | --site=sitename]"
	print "    Shorthand for '-e sitename.zexp -f sitename'."
	print "  [-s URL | --server=URL]"
	print "    URL from which to export (i.e. http://localhost:8080);"
	print "    this should be the parent URL of the folder specified"
	print "    with '-f'"
	print "  [-u username | --user=username]"
	print "    Zope username which has export permissions."
	print "  [-p pwd | --password=pwd]"
	print "    Zope user's password. Before using this option,"
	print "    you must be aware that the password will be logged"
	print "    into your .bash_history !!"
	print ""
	sys.exit(0)

if not fname:
	print "Name of the local file into which to export (es.: MySite.zexp):"
	fname = sys.stdin.readline()[:-1]
if not folder:
	print "Name of the folder to be exported from the remote site (es.: MySite):"
	folder = sys.stdin.readline()[:-1]
if not server:
	print "Zope export (parent) URL (es.: http://localhost:8080):"
	server = sys.stdin.readline()[:-1]
if not user:
	print "Zope user name: "
	user = sys.stdin.readline()[:-1]
if not passw:
	print "Zope password: "
	passw = sys.stdin.readline()[:-1]

if folder:
	URL = server + '/' + folder
else:
	URL = server

object=ZPublisher.Client.Object(URL, username=user, password=passw)

print "Exporting Zope Folder " + URL + " ..."
obj = call(object.manage_exportObject, download=1, submit="Export")
mime_msg = obj[0]
print mime_msg
print "... writing to " + fname + ' ...'
file=open(fname, 'w')
file.write(obj[1])
file.close()
print "... done."
