#!/usr/bin/python

# download_site.py
#   by Tommaso Cucinotta
#   t.cucinotta@sssup.it
#   March, 2001
#   Pisa, Italy

zope_root = '/usr/local/Zope/Zope-2.3.0-linux2-x86'

def call(f, *args, **kw):
    # Call a function ignoring redirect bci errors.
    try:
	s = apply(f,args, kw)
	return s
    except ServerError, v:
        if str(v)[:1] != '3':
            raise sys.exc_info()[0], sys.exc_info()[1], sys.exc_info()[2]

import os, sys
sys.path.insert(0,zope_root + '/lib/python')
import ZPublisher.Client
global ServerError
ServerError=ZPublisher.Client.ServerError

folder = fname = server = user = passw = ''
help=0

# Skip script name (argv[0])
i = 1
while (i < len(sys.argv)):
	arg = sys.argv[i]
	i = i + 1
	if arg == '--help' or arg == '-h': help=1
	elif arg[:7] == '--site=':
		folder = arg[7:]
		fname = folder + '.zexp'
	elif arg == '-t':
		folder = sys.argv[i]
		fname = folder + '.zexp'
		i = i + 1
	elif arg[:9] == '--import=': fname = arg[9:]
	elif arg == '-i':
		fname = sys.argv[i]
		i = i + 1
	elif arg[:9] == '--folder=': folder = arg[9:]
	elif arg == '-f':
		folder = sys.argv[i]
		i = i + 1
	elif arg[:9] == '--server=': server = arg[9:]
	elif arg == '-s':
		server = sys.argv[i]
		i = i + 1
	elif arg[:7] == '--user=': user = arg[7:]
	elif arg == '-u':
		user = sys.argv[i]
		i = i + 1
	elif arg[:11] == '--password=': passw = arg[11:]
	elif arg == '-p':
		passw = sys.argv[i]
		i = i + 1
	else:
		print "Unsupported option: " + arg
		sys.exit(-1)

if help:
	print "\nSYNOPSIS"
	print "  update_site.py [options]"
	print "\nDESCRIPTION"
	print "  Imports a zope site into a running Zope server"
	print "  from a local .zexp file, eventually deleting the"
	print "  old version of the site".
	print "\nOPTIONS"
	print "  [-h | --help]"
	print "    This help screen."
	print "  [-i filename.zexp | --import=filename.zexp]"
	print "    File to be imported in Zope. It must reside in 'import/'."
	print "  [-f foldername | --folder=foldername]"
	print "    Name of the Zope folder to be eventually deleted"
	print "    before the import operation."
	print "  [-t sitename | --site=sitename]"
	print "    Shorthand for '-i sitename.zexp -f sitename'."
	print "  [-s URL | --server=URL]"
	print "    URL into which to import (i.e. http://localhost:8080)"
	print "  [-u username | --user=username]"
	print "    Zope username that will take ownership of the imported data."
	print "  [-p pwd | --password=pwd]"
	print "    Zope user's password. Before using this option,"
	print "    you must be aware that the password will be logged"
	print "    into your .bash_history !!"
	print ""
	sys.exit(0)

if not fname:
	print "Name of the file to be imported (es.: MySite.zexp):"
	fname = sys.stdin.readline()[:-1]
if not folder:
	print "Name of the folder to be eventually replaced (es.: MySite):"
	folder = sys.stdin.readline()[:-1]
if not server:
	print "Zope import URL (es.: http://localhost:8080):"
	server = sys.stdin.readline()[:-1]
if not user:
	print "Zope (non admin) user name: "
	user = sys.stdin.readline()[:-1]
if not passw:
	print "Password: "
	passw = sys.stdin.readline()[:-1]

print fname, server, user, passw

object=ZPublisher.Client.Object(server, username=user, password=passw)

print "Eventually deleting old site instance: '" + server + '/' + fname + "'..."
print call(object.manage_delObjects, ids=folder)
print "Submitting import request..."
print call(object.manage_importObject, file=fname, set_owner=1, submit="Import")
print "...End."
